#ifndef _vc_h_
#define _vc_h_

#include <stdio.h>

#define MAX(a,b) ((a)>(b) ? (a):(b))
#define MIN(a,b) ((a)>(b) ? (b):(a))
#define swap(a,b) (temp=a,a=b,b=temp)

class point
   {
   public:
      point();
      ~point();
      void Init();
      double val[4];
      char *xyz;
      int xi,yi,zi,r1,r2;
   };

class VC
  {
  public:
     VC();
     ~VC();
     int VectorCalc(char *dspr[]);
  private:
     int ValidateInput();
     int Init();
     void SortMinMax();
     int ColinearitySearch();
     void DistVectSort(int sr);
     int VectorComponentVerify();
     void WriteHTML();
     point c1[4],c2[100],max,min;
     double colinMin,distMax,x,y,z,x1,y1,z1;
     int idxArray[100],idxArray1[100],idxArray2[100],depCount,destCount;
     char *fileBuff,*resultsBuff,*tempBuff;
     FILE *dataFile;
     };

double line_seg_point_dist_3d(double x1,double y1,double z1,double x2,double y2,double z2,
                              double x,double y,double z);
double RoundToDecimal(double dp,int d);
void vector_unit_3d(double *x1,double *y1,double *z1);
void Euclidian_ST(double *x,double *y,double *z);
void ST_Euclidian(double *x,double *y,double *z);
void StrCoords(point &c,double x,double y,double z,char s,char iformat);
void EnumCoords(point &c,double *x,double *y,double *z);
void ExtrapolatePoints(point &c0,point &c1,point &c2,point &c3);
double triangle_area_3d (double x1,double y1,double z1,double x2,double y2,double z2,
                         double x3,double y3,double z3 );
double enorm0_3d (double x0,double y0,double z0,double x1,double y1,double z1);
void vector_unit_3d(double *x1,double *y1,double *z1);
double points_colin_3d (double x1,double y1,double z1,double x2,double y2,double z2,
                        double x3,double y3,double z3 );
void cross_3d(float x1,float y1,float z1,float x2,float y2,float z2,float *x3,float *y3,float *z3);
void ExecOnExit();

#endif
